routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::resource('/products', 'ProductsController', ['except' => ['show']]);

Route::resource('/orders', 'OrdersController');
Route::resource('/specialorders', 'SpecialOrdersController');

Route::resource('/customers', 'CustomersController');

Route::get('deploy', 'DeployController@index')->name('deploy.index');
Route::post('deploy', 'DeployController@execute')->name('deploy.execute');

Route::get('/summary', 'DashboardController@summary')->name('dashboard.summary');
Route::any('/', array( 'as' => 'home', 'uses' => 'DashboardController' ));

Auth::routes();

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    /*
    In addition, Eloquent assumes that the primary key is an incrementing integer value,
    which means that by default the primary key will automatically be cast to an int.
    If you wish to use a non-incrementing or a non-numeric primary key you must
    set the public $incrementing property on your model to false
    */
    protected $keyType = 'string';
    public $incrementing = false;
    protected $primaryKey = 'name';

    protected $casts = [
        'slice_numbers' => 'collection',
    ];
}

app/Http/Controllers/ProductsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Product;

class ProductsController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('products.index')->with('products', Product::all());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('products.create')->with('products', Product::all());
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'form_name' => 'bail|required|unique:products,name',
            'form_weight' => 'numeric',
            'form_energy' => 'numeric',
            'form_splice_numbers' => 'string',
            'form_price' => 'numeric'
        ]);

        $path = null;
        if ($request->hasFile('thumbnailFile')) {
            $allowedfileExtension = ['jpeg', 'jpg'];
            $thumbnail = $request->file('thumbnailFile');

            $extension = $thumbnail->getClientOriginalExtension();
            $check = in_array($extension, $allowedfileExtension);

            if ($check) {
                $path = $thumbnail->store('product_thumbnails');
            }
        }

        $product = new Product();
        $product->name = $request->form_name;
        $product->weight = $request->form_weight;
        $product->energy = $request->form_energy;
        $product->slice_numbers = $request->slices;
        $product->price = $request->form_price;
        $product->thumbnail = $path;
        $product->save();

        return redirect()->back();
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $product = Product::where('id', $id)->first();
        return view('products.edit')->with('product', $product);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'form_name' => 'bail|required',
            'form_weight' => 'numeric',
            'form_energy' => 'numeric',
            'form_splice_numbers' => 'string',
            'form_price' => 'numeric'
        ]);

        $product = Product::where('id', $id)->first();

        if ($request->hasFile('thumbnail')) {
            $allowedfileExtension = ['jpeg', 'jpg'];
            $thumbnail = $request->file('thumbnail');

            $extension = $thumbnail->getClientOriginalExtension();
            $check = in_array($extension, $allowedfileExtension);

            if ($check) {
                $path = $thumbnail->store('product_thumbnails');
                $product->thumbnail = $path;
            }
        }

        $product->weight = $request->form_weight;
        $product->energy = $request->form_energy;
        $product->slice_numbers = $request->slices;
        $product->price = $request->form_price;
        $product->save();

        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  string  $name
     * @return \Illuminate\Http\Response
     */
    public function destroy($name)
    {
        Product::destroy($name);

        return redirect()->back();
    }
}

resources/views/products/create.blade.php
@extends('layouts.app')

@section('content-header')
<!-- Content Header (Page header) -->
<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1>Product - Create</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="#">Home</a></li>
                    <li class="breadcrumb-item active">Products</li>
                </ol>
            </div>
        </div>
    </div>
    <!-- /.container-fluid -->
</section>
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-12">
            <div class="card">

                <div class="card-header">
                    <h3 class="card-title">New Product</h3>

                    <div class="card-tools">
                        <!-- Buttons, labels, and many other things can be placed here! -->
                        <!-- Here is a label for example -->
                    </div>

                </div>

                <div class="card-body">

                    <form id="createProductForm" action="{{action('ProductsController@store')}}" method="POST" enctype="multipart/form-data">
                        @csrf

                        <div class="row">
                            <div class="col-6">
                                <div class="form-group">
                                    <div class="label">Name</div>
                                    <input type="text" class="form-control" name="form_name" id="name" placeholder="Name" required>
                                </div>
                            </div>
                            <div class="col-6">
                                <div class="form-group">
                                    <div class="label">Price (HUF)</div>
                                    <input type="number" class="form-control" name="form_price" id="price" step="0.01" min="0" value="400.00" required>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-3">
                                <div class="form-group">
                                    <div class="label">Weight (g)</div>
                                    <input type="number" class="form-control" name="form_weight" id="weight" step="0.01" min="0" value="17.20" required>
                                </div>
                            </div>
                            <div class="col-3">
                                <div class="form-group">
                                    <div class="label">Energy (kcal)</div>
                                    <input type="number" class="form-control" name="form_energy" id="energy" step="0.01" min="0" value="332.70" required>
                                </div>
                            </div>
                            <div class="col-6">
                                <label for="slices_number_label">
                                    Number of Slices:

                                    <select class="slices-multiple js-states form-control" name="slices[]" multiple="multiple" id="slices_number_label" style="width: 75%">
                                        <option value="8" selected>8 sz</option>
                                        <option value="12" selected>12 sz</option>
                                        <option value="16" selected>16 sz</option>
                                        <option value="32" selected>32 sz</option>
                                    </select>
                                </label>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-6">

                                <div class="form-group">
                                    <label for="thumbnailFile">Upload thumbnail</label>
                                    <div class="input-group">
                                        <!-- https://github.com/Johann-S/bs-custom-file-input -->
                                        <div class="custom-file">
                                            <label class="custom-file-label" for="thumbnailFile">Choose file</label>
                                            <input type="file" class="form-control" id="thumbnailFile" name="thumbnailFile" accept=".jpg,.jpeg">
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>

                    </form>
                </div>
                {{-- CardBody --}}

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary" form="createProductForm">Submit</button>
                </div>

            </div>
            {{-- card --}}

        </div>
    </div>
</section>

@endsection

@section('customjs')
<script src="{{ asset('AdminLTE/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<script>
    $(function() {

        //Initialize Select2 Elements
        $('.slices-multiple').select2({
            theme: "classic"
        });

        // https://github.com/Johann-S/bs-custom-file-input
        bsCustomFileInput.init()
    });
</script>
@endsection

resources/views/products/edit.blade.php
@extends('layouts.app')

@section('content-header')
<!-- Content Header (Page header) -->
<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1>Product - Edit</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="#">Home</a></li>
                    <li class="breadcrumb-item active">Products</li>
                </ol>
            </div>
        </div>
    </div>
    <!-- /.container-fluid -->
</section>
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-12">
            <div class="card">

                <div class="card-header">
                    <h3 class="card-title">Edit Product</h3>

                    <div class="card-tools">
                        <!-- Buttons, labels, and many other things can be placed here! -->
                        <!-- Here is a label for example -->
                    </div>

                </div>

                <div class="card-body">

                    <form id="createProductForm" action="{{ route('products.update', $product->id)}}" method="POST" enctype="multipart/form-data">
                        @csrf

                        <div class="row">
                            <div class="col-6">
                                <div class="form-group">
                                    <div class="label">Name</div>
                                    <input type="text" class="form-control" name="form_name" id="name" value="{{$product->name}}" required>
                                </div>
                            </div>
                            <div class="col-6">
                                <div class="form-group">
                                    <div class="label">Price (HUF)</div>
                                    <input type="number" class="form-control" name="form_price" id="price" step="0.01" min="0" value="{{$product->price}}" required>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-3">
                                <div class="form-group">
                                    <div class="label">Weight (g)</div>
                                    <input type="number" class="form-control" name="form_weight" id="weight" step="0.01" min="0" value="{{$product->weight}}" required>
                                </div>
                            </div>
                            <div class="col-3">
                                <div class="form-group">
                                    <div class="label">Energy (kcal)</div>
                                    <input type="number" class="form-control" name="form_energy" id="energy" step="0.01" min="0" value="{{$product->energy}}" required>
                                </div>
                            </div>
                            <div class="col-6">
                                <label for="slices_number_label">
                                    Number of Slices:

                                    <select class="slices-multiple js-states form-control" name="slices[]" multiple="multiple" id="slices_number_label" style="width: 75%">
                                        @foreach ($product->slice_numbers as $slice)
                                        <option value={{$slice}} selected>{{$slice}}</option>
                                        @endforeach
                                    </select>
                                </label>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-6">

                                <div class="form-group">
                                    <label for="thumbnailFile">Upload thumbnail to override</label>
                                    <div class="input-group">
                                        <!-- https://github.com/Johann-S/bs-custom-file-input -->
                                        <div class="custom-file">
                                            <label class="custom-file-label" for="thumbnailFile">Choose file</label>
                                            <input type="file" class="form-control" id="thumbnailFile" accept=".jpg,.jpeg">
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>

                    </form>
                </div>
                {{-- CardBody --}}

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary" form="createProductForm">Submit</button>
                </div>

            </div>
            {{-- card --}}

        </div>
    </div>
</section>

@endsection

@section('customjs')
<script src="{{ asset('AdminLTE/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<script>
    $(function() {

        //Initialize Select2 Elements
        $('.slices-multiple').select2({
            theme: "classic"
        });

        // https://github.com/Johann-S/bs-custom-file-input
        bsCustomFileInput.init()
    });
</script>
@endsection

resources/views/products/index.blade.php
@extends('layouts.app')

@section('customcss')
<!-- DataTables -->
<link rel="stylesheet" href="{{ asset('AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.css') }}">
@endsection

@section('content-header')
<!-- Content Header (Page header) -->
<section class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1>Products</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="#">Home</a></li>
                    <li class="breadcrumb-item active">Products</li>
                </ol>
            </div>
        </div>
    </div>
    <!-- /.container-fluid -->
</section>
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-12">
            <div class="card">

                <div class="card-header">
                    <h3 class="card-title">DataTable</h3>

                    <div class="card-tools">
                        <!-- Buttons, labels, and many other things can be placed here! -->
                        <!-- Here is a label for example -->
                        <a href="{{route('products.create')}}" type="button" class="btn btn-tool">
                            <i class="fas fa-plus-circle"></i>
                        </a>
                    </div>

                </div>

                <div class="card-body">
                    <div id="productsDataTable" class="dataTables_wrapper dt-bootstrap4">
                        <div class="row">
                            <div class="col-sm-12 col-md-6"></div>
                            <div class="col-sm-12 col-md-6"></div>
                        </div>
                        <div class="row">
                            <div class="col-sm-12">
                                <table class="table table-bordered table-hover dataTable table-sm" role="grid" id="productsTable">
                                    <thead>
                                        <tr>
                                            <th tabindex="0" rowspan="1" colspan="1"></th>
                                            <th class="sorting_asc" tabindex="0" rowspan="1" colspan="1">Name</th>
                                            <th class="sorting" tabindex="0" rowspan="1" colspan="1">Weight</th>
                                            <th class="sorting" tabindex="0" rowspan="1" colspan="1">Energy</th>
                                            <th class="sorting" tabindex="0" rowspan="1" colspan="1">Slice Numbers</th>
                                            <th class="sorting" tabindex="0" rowspan="1" colspan="1">Price</th>
                                            <th colspan="1">Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($products as $product)
                                        <tr role="row">
                                            <td><img src="storage/{{$product->thumbnail}}" width="40" height="30"></td>
                                            <td class="sorting_1">{{$product->name}}</td>
                                            <td>{{$product->weight}}</td>
                                            <td>{{$product->energy}}</td>
                                            <td>{{$product->slice_numbers->implode(',')}}</td>
                                            <td>{{$product->price}}</td>
                                            <td>
                                                <a href="{{ route('products.edit', $product->id) }}" class="btn btn-primary btn-sm">
                                                    <i class="fas fa-edit"></i>
                                                </a>

                                                <button class="btn btn-danger btn-sm" type="submit" form="deleteForm" formaction="{{ route('products.destroy', $product->name)}}"><i class="far fa-minus-square"></i></button>
                                            </td>
                                        </tr>
                                        @endforeach
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    {{-- productsDataTable --}}

                </div>
                {{-- CardBody --}}

            </div>
            {{-- card --}}

        </div>
    </div>
</section>

@section('customjs')

<script src="{{ asset('AdminLTE/plugins/datatables/jquery.dataTables.js')}}"></script>
<script src=" {{ asset('AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.js')}}"></script>

<script>
    $(document).ready(function() {
        $('#productsTable').DataTable({
            "columnDefs": [{
                "width": "5%",
                "targets": 0
            }],
            "order": [
                [1, "desc"]
            ]
        });
    });
</script>

@endsection

@endsection